<?php
//Parameters
// Parents AI for Boss
$aBParentAI = array(
0  => array("class" => "party_leader_ag_casting_ddmagic", "magic" => "DDMagic"),
1  => array("class" => "party_leader_ag_physicalspecial", "magic" =>  "PhysicalSpecial"),
2  => array("class" => "party_leader_casting_ddmagic", "magic" =>  "DDMagic"),
3  => array("class" => "party_leader_physicalspecial", "magic" =>  "PhysicalSpecial"),
4  => array("class" => "warrior_passive", "magic" =>  "0"),
5  => array("class" => "warrior_aggressive", "magic" =>  "0"),
6  => array("class" => "warrior_passive_use_bow", "magic" =>  "0"),
7  => array("class" => "warrior_aggressive_use_bow", "magic" =>  "0"),
8  => array("class" => "warrior_passive_use_power_shot", "magic" =>  "0"),
9  => array("class" => "warrior_aggressive_use_power_shot", "magic" =>  "0"),
10 => array("class" => "warrior_passive_physicalspecial", "magic" =>  "PhysicalSpecial"),
11 => array("class" => "warrior_aggressive_physicalspecial", "magic" =>  "PhysicalSpecial"),
12 => array("class" => "warrior_passive_casting_curse", "magic" =>  "DeBuff"),
13 => array("class" => "warrior_aggressive_casting_curse", "magic" =>  "DeBuff"),
14 => array("class" => "warrior_passive_casting_enchant_self", "magic" =>  "Buff"),
15 => array("class" => "warrior_aggressive_casting_enchant_self", "magic" =>  "Buff"),
16 => array("class" => "warrior_passive_casting_enchant_clan", "magic" =>  "Buff"),
17 => array("class" => "warrior_aggressive_casting_enchant_clan", "magic" =>  "Buff"),
18 => array("class" => "warrior_passive_casting_ddmagic", "magic" =>  "DDMagic"),
19 => array("class" => "warrior_aggressive_casting_ddmagic", "magic" =>  "DDMagic"),
20 => array("class" => "warrior_passive_casting_hold_magic", "magic" =>  "HoldMagic"),
21 => array("class" => "warrior_aggressive_casting_hold_magic", "magic" =>  "HoldMagic"),
22 => array("class" => "warrior_passive_casting_sleep_magic", "magic" =>  "SleepMagic"),
23 => array("class" => "warrior_aggressive_casting_sleep_magic", "magic" =>  "SleepMagic"),
24 => array("class" => "warrior_pa_casting_heal", "magic" =>  "MagicHeal"),
25 => array("class" => "warrior_ag_casting_heal", "magic" =>  "MagicHeal"),
26 => array("class" => "warrior_pa_casting_cancel", "magic" =>  "CancelMagic"),
27 => array("class" => "warrior_ag_casting_cancel", "magic" =>  "CancelMagic"),
28 => array("class" => "warrior_passive_run_away_to_clan", "magic" =>  "0"),
29 => array("class" => "warrior_aggressive_run_away_to_clan", "magic" =>  "0")
);

// Parents AI for Privaters
$aBPParentAI = array(
0  => "party_private_physicalspecial",
1  => "party_private_physicalspecial_power_shot",
2  => "party_private_casting_curse",
3  => "party_private_casting_enchant",
4  => "party_private"
);

// Defaults
$eol = "\n";
if (!isset($bpai))    $bpai = 4;
if (!isset($bp1pai))  $bp1pai = 0;
if (!isset($bp2pai))  $bp2pai = 2;
if (!isset($bp1nums)) $bp1nums = 2;
if (!isset($bp2nums)) $bp2nums = 2;
if (!isset($bp1resp)   or empty($bp1resp))   $bp1resp = 10;
if (!isset($bp2resp)   or empty($bp2resp))   $bp2resp = 10;
if (!isset($bskilll)   or empty($bskilll))   $bskilll = 1;
if (!isset($bp1skilll) or empty($bp1skilll)) $bp1skilll = 1;
if (!isset($bp2skilll) or empty($bp2skilll)) $bp2skilll = 1;

// Work
if ($w == 1 and !empty($bname))
{
	$resai = "";

// Boss AI
	if (empty($bai)) $bai = $bname;
	$resai .= "class {$bai} : ".$aBParentAI[$bpai]["class"].$eol;

// Boss Parameters
// Skills string
	$ispar = false;
	if (!empty($bskill))
	{
		if ($aBParentAI[$bpai]["magic"] != "0")
		{
			$ispar = true;
			$skillbai = "\tint ".$aBParentAI[$bpai]["magic"]." ".($bskill * 256 + $bskilll)."{$eol}";
		}
	}
	
// Privaters string
	if (!empty($bp1name) and $bp1nums > 0)	
	{
		$ispar = true;
		if (empty($bp1ai)) $bp1ai = $bp1name;
		$strp = "{$bp1name}:{$bp1ai}:1:{$bp1resp}min;";
		$strp1 = "";
		for ($i = 0; $i < $bp1nums; $i++)
		{
			$strp1 .= $strp;
		}
	}
	if (!empty($bp2name) and $bp2nums > 0)	
	{
		$ispar = true;
		if (empty($bp2ai)) $bp2ai = $bp2name;
		$strp = "{$bp2name}:{$bp2ai}:1:{$bp2resp}min;";
		$strp2 = "";
		for ($i = 0; $i < $bp2nums; $i++)
		{
			$strp2 .= $strp;
		}
	}
	$strp = $strp1.$strp2;
	
	if ($ispar)
	{
		$resai .= "parameter_define_begin{$eol}";
		$resai .= $skillbai;
		if (!empty($strp))
		{
			$resai .= "\tstring Privates \"";
			$resai .= substr($strp, 0, strlen($strp) - 1);
			$resai .= "\"{$eol}";
		}
		$resai .= "parameter_define_end{$eol}";		
	}
	$resai .= "class_end".$eol;

// Privaters AI
// Default parameters
	$PParam  = "parameter_define_begin{$eol}";
	$PParam .= "\tfloat Attack_DecayRatio 6.600000{$eol}";
	$PParam .= "\tfloat UseSkill_DecayRatio 66000.000000{$eol}";
	$PParam .= "\tfloat Attack_BoostValue 500.000000{$eol}";
	$PParam .= "\tfloat UseSkill_BoostValue 100000.000000{$eol}";

// Privaters 1
	if (!empty($bp1name) and $bp1nums > 0)	
	{
		$resai .= "{$eol}class {$bp1ai} : ".$aBPParentAI[$bp1pai].$eol;
		$ispar = false;
		if (!empty($bp1skill))
		{
			if ($bp1pai == 0)
			{
				$skillbp1ai = "\tint PhysicalSpecial ".($bp1skill * 256 + $bp1skilll)."{$eol}";
				$ispar = true;
			}
			elseif ($bp1pai == 2)
			{
				$skillbp1ai .= "\tint DeBuff ".($bp1skill * 256 + $bp1skilll)."{$eol}";
				$ispar = true;
			}
			elseif ($bp1pai == 3)
			{
				$skillbp1ai .= "\tint Buff ".($bp1skill * 256 + $bp1skilll)."{$eol}";
				$ispar = true;
			}

			$resai .= $PParam;
			if ($ispar)
			{
				$resai .= $skillbp1ai;
			}
			$resai .= "parameter_define_end{$eol}";		
		}
		$resai .= "class_end".$eol;
	}

// Privaters 2
	if (!empty($bp2name) and $bp2nums > 0)
	{
		$resai .= "{$eol}class {$bp2ai} : ".$aBPParentAI[$bp2pai].$eol;
		$ispar = false;
		if (!empty($bp2skill))
		{
			if ($bp2pai == 0)
			{
				$skillbp2ai = "\tint PhysicalSpecial ".($bp2skill * 256 + $bp2skilll)."{$eol}";
				$ispar = true;
			}
			elseif ($bp2pai == 2)
			{
				$skillbp2ai .= "\tint DeBuff ".($bp2skill * 256 + $bp2skilll)."{$eol}";
				$ispar = true;
			}
			elseif ($bp2pai == 3)
			{
				$skillbp2ai .= "\tint Buff ".($bp2skill * 256 + $bp2skilll)."{$eol}";
				$ispar = true;
			}

			$resai .= $PParam;
			if ($ispar)
			{
				$resai .= $skillbp2ai;
			}
			$resai .= "parameter_define_end{$eol}";
		}
		$resai .= "class_end".$eol;
	}
}
?>
<html>
<head>
<title>Make NPC AI</title>
<STYLE type=text/css>
body		{font-family: Verdana; font-size: 8px; color: white; BACKGROUND: #0b283b}
table		{font-family: Verdana; font-size: 8pt; color: white; }
td.header	{font-family: Tahoma;  font-size: 11px; color: snow; font-weight: bold}
td.body		{font-family: Verdana; font-size: 11px; color: white;}
td.toph		{font-family: Verdana; font-size: 8pt; color: white; background-color: black; border-bottom: gray 1pt solid; border-left: gray 1pt solid; border-right: gray 1pt solid; border-top: gray 1pt solid}
td.top		{font-family: Verdana; font-size: 8pt; color: white; border-bottom: gray 1pt solid; border-left: gray 1pt solid; border-right: gray 1pt solid; border-top: gray 1pt solid}
td.nob		{font-family: Verdana; font-size: 8pt; color: white; border-bottom: 0pt; border-left: 0pt; border-right: 0pt; border-top: 0pt}
td.s		{font-family: Verdana; font-size: 7pt; color: white; border-bottom: gray 1pt solid; border-left: gray 1pt solid; border-right: gray 1pt solid; border-top: gray 1pt solid}
td.sn		{font-family: Verdana; font-size: 7pt; color: red; border-bottom: gray 1pt solid; border-left: gray 1pt solid; border-right: gray 1pt solid; border-top: gray 1pt solid}
select		{font-family: verdana; font-size: 8pt; color: white; background-color: #202020; border-right: black 1px solid; border-top: black 1px solid; border-left: black 1px solid; border-bottom: black 1px solid;}
input		{font-family: verdana; font-size: 8pt; background-color: #202020; border-right: #ffffff 1px solid; border-top: #ffffff 1px solid; border-left: #ffffff 1px solid; color: #ffffff; border-bottom: #ffffff 1px solid;}
textarea	{font-family: verdana; font-size: 8pt; background-color: #202020; border-right: #ffffff 1px solid; border-top: #ffffff 1px solid; border-left: #ffffff 1px solid; color: #ffffff; border-bottom: #ffffff 1px solid;}
</STYLE>
<script>
function ViewSkills(id, type)
{
	if (id != '')
		window.open('npc_skills.php?t='+type+'&id='+id, 'npc_skills', 'width=400 height=250 scrollbars=yes');
	else
		alert("Empty field");
}

</script>
</head>
<body TOPMARGIN=5>
<table align=center cellPadding=2 cellSpacing=0 border=0>
<form name=param id=param action=ai.php method=post>
<input type=hidden name=w value=1>
<tr>	
	<td class=toph align=center colspan=2><b>NPC</td>
</tr>
<tr>	
	<td width=400 align=right>ID (from npcdata.txt):</td>
	<td width=400 align=left>
		<input type=text name=id_npc value="<?=$id_npc?>" style="width:200px">
		<input type=button value="View skills by ID" style="color:yellow; width:195px" onclick="ViewSkills(document.param.id_npc.value, 1)">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Name (from npcdata.txt):</td>
	<td width=400 align=left>
		<input type=text name=bname value="<?=$bname?>" style="width:200px">
		<input type=button value="View skills by name" style="color:yellow; width:195px" onclick="ViewSkills(document.param.bname.value, 2)">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Skill ID (from mobskillanimgrp.dat):</td>
	<td width=400 align=left>
		<input type=text name=bskill value="<?=$bskill?>" style="width:300px"> Skill level: <input type=text name=bskilll value="<?=$bskilll?>" style="width:32px">
	</td>
</tr>
<!--<tr>	
	<td width=400 align=right>AI (if empty = name):</td>
	<td width=400 align=left>
		<input type=text name=bai value="<?=$bai?>" style="width:400px">
	</td>
</tr>-->
<tr>	
	<td width=400 align=right>Parent AI class:</td>
	<td width=400 align=left>
		<select name=bpai style="width:400px"><?php
for ($i = 0; $i < sizeof($aBParentAI); $i++)
{
	echo "<option value={$i}";
	if ($i == $bpai) echo " selected";
	echo ">".$aBParentAI[$i]["class"]."</option>";
}
?></select>
	</td>
</tr>

<tr>	
	<td class=toph align=center colspan=2><b>Privaters One</td>
</tr>
<tr>	
	<td width=400 align=right>ID (from npcdata.txt):</td>
	<td width=400 align=left>
		<input type=text name=id_npc_p1 value="<?=$id_npc_p1?>" style="width:200px">
		<input type=button value="View skills by ID" style="color:yellow; width:195px"  onclick="ViewSkills(document.param.id_npc_p1.value, 1)">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Name (from npcdata.txt):</td>
	<td width=400 align=left>
		<input type=text name=bp1name value="<?=$bp1name?>" style="width:200px">
		<input type=button value="View skills by name" style="color:yellow; width:195px" onclick="ViewSkills(document.param.bp1name.value, 2)">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Skill ID (from mobskillanimgrp.dat):</td>
	<td width=400 align=left>
		<input type=text name=bp1skill value="<?=$bp1skill?>" style="width:300px"> Skill level: <input type=text name=bp1skilll value="<?=$bp1skilll?>" style="width:32px">
	</td>
</tr>
<!--<tr>	
	<td width=400 align=right>AI (if empty = name):</td>
	<td width=400 align=left>
		<input type=text name=bp1ai value="<?=$bp1ai?>" style="width:400px">
	</td>
</tr>-->
<tr>	
	<td width=400 align=right>Parent AI class:</td>
	<td width=400 align=left>
		<select name=bp1pai style="width:400px"><?php
for ($i = 0; $i < sizeof($aBPParentAI); $i++)
{
	echo "<option value={$i}";
	if ($i == $bp1pai) echo " selected";
	echo ">".$aBPParentAI[$i]."</option>";
}
?></select>
	</td>
</tr>
<tr>	
	<td width=400 align=right>Nums:</td>
	<td width=400 align=left>
		<input type=text name=bp1nums value="<?=$bp1nums?>" style="width:150px"> Respawn (min): <input type=text name=bp1resp value="<?=$bp1resp?>" style="width:151px">
	</td>
</tr>

<tr>	
	<td class=toph align=center colspan=2><b>Privaters Two</td>
</tr>
<tr>	
	<td width=400 align=right>ID (from npcdata.txt):</td>
	<td width=400 align=left>
		<input type=text name=id_npc_p2 value="<?=$id_npc_p2?>" style="width:200px">
		<input type=button value="View skills by ID" style="color:yellow; width:195px"  onclick="ViewSkills(document.param.id_npc_p2.value, 1)">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Name (from npcdata.txt):</td>
	<td width=400 align=left>
		<input type=text name=bp2name value="<?=$bp2name?>" style="width:200px">
		<input type=button value="View skills by name" style="color:yellow; width:195px" onclick="ViewSkills(document.param.bp2name.value, 2)">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Skill ID (from mobskillanimgrp.dat):</td>
	<td width=400 align=left>
		<input type=text name=bp2skill value="<?=$bp2skill?>" style="width:300px"> Skill level: <input type=text name=bp2skilll value="<?=$bp2skilll?>" style="width:32px">
	</td>
</tr>
<!--<tr>	
	<td width=400 align=right>AI (if empty = name):</td>
	<td width=400 align=left>
		<input type=text name=bp2ai value="<?=$bp2ai?>" style="width:400px">
	</td>
</tr>-->
<tr>	
	<td width=400 align=right>Parent AI class:</td>
	<td width=400 align=left>
		<select name=bp2pai style="width:400px"><?php
for ($i = 0; $i < sizeof($aBPParentAI); $i++)
{
	echo "<option value={$i}";
	if ($i == $bp2pai) echo " selected";
	echo ">".$aBPParentAI[$i]."</option>";
}
?></select>
	</td>
</tr>
<tr>	
	<td width=400 align=right>Nums:</td>
	<td width=400 align=left>
		<input type=text name=bp2nums value="<?=$bp2nums?>" style="width:150px"> Respawn (min): <input type=text name=bp2resp value="<?=$bp2resp?>" style="width:151px">
	</td>
</tr>
<tr height=50>	
	<td align=center colspan=2>
		<input type=submit style="width:150px;color:yellow" value=" Make AI ">
		<input type=button value='Clear fields' style='width:150px;color: red' onclick='window.location="ai.php"' title='Set all fields to default '>
	</td>
</tr>
<tr>	
	<td class=toph align=center colspan=2>AI</td>
</tr>
<tr>	
	<td align=center colspan=2>
	<textarea name=resai rows=20 cols=130><?=$resai?></textarea>
	</td>
</tr>
</form>
</table>
<center><small>&copy; PhD
</body>
</html>
