<?php
//  0 - class
if (!isset($class)) $class = 1;
$aClass = array(
 1 => array("name" => "Common NPC",		"c_sp" =>  1.0,"c_hp" =>   1.0,"c_mp" => 1.0,	"c_pa" =>  1.0,"c_pd" =>  1.0,"c_ma" =>  1.0,"c_md" => 1.0),
 2 => array("name" => "Alone RAID Boss",	"c_sp" => 50.0,"c_hp" => 160.0,"c_mp" => 2.5,	"c_pa" => 10.0,"c_pd" => 10.0,"c_ma" => 10.0,"c_md" => 5.0),
 3 => array("name" => "Party RAID Boss",	"c_sp" => 25.0,"c_hp" =>  80.0,"c_mp" => 2.5,	"c_pa" =>  5.0,"c_pd" => 10.0,"c_ma" =>  5.0,"c_md" => 5.0),
 4 => array("name" => "RAID Fighter",		"c_sp" => 12.5,"c_hp" =>  40.0,"c_mp" => 2.5,	"c_pa" =>  2.5,"c_pd" =>  5.0,"c_ma" =>  2.5,"c_md" => 2.5)
);

//  1 - type
if (!isset($type)) $type = 19;
$aType = array(
 1 => 'blacksmith',
 2 => 'boss',
 3 => 'castle_gate',
 4 => 'chamberlain',
 5 => 'citizen',
 6 => 'guard',
 7 => 'guild_coach',
 8 => 'guild_master',
 9 => 'holything',
10 => 'house_master',
11 => 'merchant',
12 => 'object',
13 => 'package_keeper',
14 => 'pet',
15 => 'summon',
16 => 'teleporter',
17 => 'temptrainer',
18 => 'warehouse_keeper',
19 => 'warrior'
);

//  1.1 - id
if (!isset($id)) $id = 0;

//  2 - name
if (!isset($name)) $name = '';

//  3 - level
if (!isset($level) or $level < 20) $level = 20;

//  4 - acquire_exp_rate
if (!isset($acquire_exp_rate)) $acquire_exp_rate = 1.5;

//  6 - race
if (!isset($race)) $race = 15;
$aRace = array(
 1 => array("name" => "animal",		"skill" => "@s_animal_weakness"),           
 2 => array("name" => "beast",		"skill" => "@s_beast_weakness"),
 3 => array("name" => "bug",		"skill" => "@s_insect_skin;@s_bug_weakness"),
 4 => array("name" => "castle_guard",	"skill" => "@s_full_magic_defence"),      
 5 => array("name" => "construct",	"skill" => "@s_golem_body;@s_strong_to_bow"),      
 6 => array("name" => "darkelf",	"skill" => "@s_full_magic_defence"),      
 7 => array("name" => "demonic",	"skill" => ""),     
 8 => array("name" => "dragon",	  	"skill" => "@s_dragon_weakness"),      
 9 => array("name" => "dwarf",		"skill" => "@s_full_magic_defence"),        
10 => array("name" => "elemental",	"skill" => ""),      
11 => array("name" => "elf",		"skill" => "@s_full_magic_defence"),      
12 => array("name" => "fairy",		"skill" => "@s_floating_target"),
13 => array("name" => "giant",		"skill" => ""),      
14 => array("name" => "human",		"skill" => "@s_full_magic_defence"),      
15 => array("name" => "humanoid",	"skill" => ""),
16 => array("name" => "mercenary",	"skill" => "@s_full_magic_defence"),      
17 => array("name" => "monster",	"skill" => ""),     
18 => array("name" => "orc",		"skill" => "@s_full_magic_defence"),     
19 => array("name" => "plant",		"skill" => "@s_plant_weakness"),     
20 => array("name" => "undead",		"skill" => "@s_unholy"),
21 => array("name" => "divine",		"skill" => ""),
22 => array("name" => "spirit",		"skill" => "")
);

//  7 - skill_list
if (!isset($skill_list)) $skill_list = '';

//  8 - corpse_make_list
if (!isset($corpse_make_list)) $corpse_make_list = '{[magic_ring];1;1;12.0603};{[stem];1;1;3.9799}';

//  9 - additional_make_list
if (!isset($additional_make_list)) $additional_make_list = '';

// 10 - additional_make_multi_list
if (!isset($additional_make_multi_list)) $additional_make_multi_list = '{{{[adena];7;10;100}};70};{{{[stem];1;1;75};{[suede];1;1;25}};1.3062}';

// 11 - slot_rhand
if (!isset($slot_rhand)) $slot_rhand = 1;
$aSlot_rhand = array(
 1 => array("name" => "", 			"type" => ""),
 2 => array("name" => "apprentice's_rod", 	"type" => "magic blunt"),
 3 => array("name" => "assassin_knife", 	"type" => "dagger"),
 4 => array("name" => "bastard_sword", 		"type" => "sword"),
 5 => array("name" => "battle_axe", 		"type" => "blunt"),
 6 => array("name" => "big_hammer", 		"type" => "blunt"),
 7 => array("name" => "bone_dagger", 		"type" => "dagger"),
 8 => array("name" => "bonebreaker", 		"type" => "sword"),
 9 => array("name" => "bow", 			"type" => "bow"),
10 => array("name" => "broad_sword", 		"type" => "sword"),
11 => array("name" => "caliburs", 		"type" => "sword"),
12 => array("name" => "cedar_staff", 		"type" => "magic blunt"),
13 => array("name" => "claymore", 		"type" => "blunt"),
14 => array("name" => "club", 			"type" => "blunt"),
15 => array("name" => "club_of_nature", 	"type" => "magic blunt"),
16 => array("name" => "crimson_sword", 		"type" => "sword"),
17 => array("name" => "dagger", 		"type" => "dagger"),
18 => array("name" => "dirk", 			"type" => "dagger"),
19 => array("name" => "dreadbane", 		"type" => "pole"),
20 => array("name" => "elemental_sword",	"type" => "sword"),
21 => array("name" => "falchion", 		"type" => "2h sword"),
22 => array("name" => "giant_bar", 		"type" => "pole"),
23 => array("name" => "giant_cannon", 		"type" => "sword"),
24 => array("name" => "giant_rod", 		"type" => "pole"),
25 => array("name" => "gladius", 		"type" => "sword"),
26 => array("name" => "glaive", 		"type" => "pole"),
27 => array("name" => "great_axe", 		"type" => "blunt"),
28 => array("name" => "great_sword", 		"type" => "2h sword"),
29 => array("name" => "guard_spear", 		"type" => "pole"),
30 => array("name" => "halbard", 		"type" => "blunt"),
31 => array("name" => "hand_axe", 		"type" => "blunt"),
32 => array("name" => "knife", 			"type" => "dagger"),
33 => array("name" => "kukuri", 		"type" => "dagger"),
34 => array("name" => "lizardspear", 		"type" => "pole"),
35 => array("name" => "long_bow", 		"type" => "bow"),
36 => array("name" => "long_spear", 		"type" => "pole"),
37 => array("name" => "long_sword", 		"type" => "sword"),
38 => array("name" => "mace", 			"type" => "blunt"),
39 => array("name" => "mace_of_prayer", 	"type" => "magic blunt"),
40 => array("name" => "mist_sword", 		"type" => "sword"),
41 => array("name" => "morning_star", 		"type" => "blunt"),
42 => array("name" => "orcish_poleaxe", 	"type" => "pole"),
43 => array("name" => "orcish_sword", 		"type" => "sword"),
44 => array("name" => "saber", 			"type" => "sword"),
45 => array("name" => "scorpion", 		"type" => "pole"),
46 => array("name" => "shamshir", 		"type" => "sword"),
47 => array("name" => "shining_knife", 		"type" => "dagger"),
48 => array("name" => "short_bow", 		"type" => "bow"),
49 => array("name" => "skeleton_dagger",	"type" => "dagger"),
50 => array("name" => "skull_breaker", 		"type" => "sword"),
51 => array("name" => "small_sword", 		"type" => "sword"),
52 => array("name" => "spike_club", 		"type" => "blunt"),
53 => array("name" => "sprite's_staff", 	"type" => "magic blunt"),
54 => array("name" => "stormbringer", 		"type" => "sword"),
55 => array("name" => "sword_of_damascus", 	"type" => "sword"),
56 => array("name" => "sword_of_watershadow", 	"type" => "sword"),
57 => array("name" => "tarbar", 		"type" => "blunt"),
58 => array("name" => "throw_knife", 		"type" => "dagger"),
59 => array("name" => "tomahawk", 		"type" => "blunt"),
60 => array("name" => "trident", 		"type" => "pole"),
61 => array("name" => "tsurugi", 		"type" => "sword"),
62 => array("name" => "two-handed_sword", 	"type" => "2h sword"),
63 => array("name" => "winged_spear", 		"type" => "pole"),
64 => array("name" => "shining_bow", 		"type" => "bow")
);

// 12 - slot_lhand
if (!isset($slot_lhand)) $slot_lhand = 1;
$aSlot_lhand = array(
 1 => '',
 2 => 'buckler',
 3 => 'chain_shield',
 4 => 'leather_shield',
 5 => 'round_shield',
 6 => 'shield_of_victory',
 7 => 'skeleton_buckler',
 8 => 'small_shield',
 9 => 'composite_shield',
10 => 'doom_shield',
11 => 'avadon_shield'
);

// 13 - base_attack_type
if (!isset($base_attack_type)) $base_attack_type = 4;
$aBase_attack_type = array(
 1 => array("name" => "blunt",	"base_attack_range" =>  40,"base_rand_dam" => 50,"physical_hit_modify" =>    9,"base_attack_speed" => 253,"base_reuse_delay" =>    0,"base_critical" =>  1,"base_damage_range" => "{0;0;40;120}"),
 2 => array("name" => "bow",	"base_attack_range" => 500,"base_rand_dam" => 10,"physical_hit_modify" =>    0,"base_attack_speed" => 227,"base_reuse_delay" => 1500,"base_critical" =>  8,"base_damage_range" => "{0;0;10;0}"),
 3 => array("name" => "dagger",	"base_attack_range" =>  40,"base_rand_dam" => 10,"physical_hit_modify" =>    0,"base_attack_speed" => 289,"base_reuse_delay" =>    0,"base_critical" =>  8,"base_damage_range" => "{0;0;40;120}"),
 4 => array("name" => "fist",	"base_attack_range" =>  40,"base_rand_dam" =>  7,"physical_hit_modify" => 4.75,"base_attack_speed" => 253,"base_reuse_delay" =>    0,"base_critical" =>  4,"base_damage_range" => "{0;0;40;90}"),
 5 => array("name" => "pole",	"base_attack_range" =>  80,"base_rand_dam" =>  0,"physical_hit_modify" =>   10,"base_attack_speed" => 325,"base_reuse_delay" =>    0,"base_critical" =>  8,"base_damage_range" => "{0;0;66;120}"),
 6 => array("name" => "sword",	"base_attack_range" =>  40,"base_rand_dam" => 30,"physical_hit_modify" => 4.75,"base_attack_speed" => 253,"base_reuse_delay" =>    0,"base_critical" =>  4,"base_damage_range" => "{0;0;40;120}")
);

// 14 - str=40
if (!isset($str)) $str = 40;

// 15 - int=21
if (!isset($int)) $int = 21;

// 16 - dex=30
if (!isset($dex)) $dex = 30;

// 17 - wit=20
if (!isset($wit)) $wit = 20;

// 18 - con=43
if (!isset($con)) $con = 43;

// 19 - men=10
if (!isset($men)) $men = 10;

// 20 - hp_increase=10	
if (!isset($hp_increase)) $hp_increase = 40;

// 21 - mp_increase=5
if (!isset($mp_increase)) $mp_increase = 7;

// 22 - org_hp_regen=2
if (!isset($org_hp_regen)) $org_hp_regen = 7;

// 23 - org_mp_regen=1
if (!isset($org_mp_regen)) $org_mp_regen = 3;

// 24 - walk_speed
if (!isset($walk_speed)) $walk_speed = 50;

// 25 - run_speed
if (!isset($run_speed)) $run_speed = 150;

// 26 - fly (0/1)
if (!isset($fly)) $fly = 0;

// 27 - float (0/1)
if (!isset($float)) $float = 0;

// 28 - hp_coeff
if (!isset($hp_coeff)) $hp_coeff = 1.0;

// 29 - mp_coeff
if (!isset($mp_coeff)) $mp_coeff = 1.0;

// 30 - patk_coeff
if (!isset($patk_coeff)) $patk_coeff = 1.0;

// 31 - pdef_coeff
if (!isset($pdef_coeff)) $pdef_coeff = 1.0;

// 32 - matk_coeff
if (!isset($matk_coeff)) $matk_coeff = 1.0;

// 33 - mdef_coeff
if (!isset($mdef_coeff)) $mdef_coeff = 1.0;

// 35 - collision_radius
if (!isset($collision_radius)) $collision_radius = 10;

// 36 - collision_height
if (!isset($collision_height)) $collision_height = 15;

// 37 - clan
if (!isset($clan)) $clan = 1;
$aClan = array(
 1 => '',
 2 => '@abyss_jewel_clan',
 3 => '@aden_siege_clan',
 4 => '@all_elemental_clan',
 5 => '@all_elemental2_clan',
 6 => '@ant_clan',
 7 => '@bapuk_clan',
 8 => '@bugbear_clan',
 9 => '@cave_servant_clan',
10 => '@curma_core_clan',
11 => '@demonic_clan',
12 => '@dion_siege_clan',
13 => '@door_clan',
14 => '@dragon_clan',
15 => '@elemental_clan',
16 => '@elemental1_clan',
17 => '@elemental2_clan',
18 => '@elemental3_clan',
19 => '@elemental4_clan',
20 => '@ghost_clan',
21 => '@giant_clan',
22 => '@giant_leech_clan',
23 => '@giran_siege_clan',
24 => '@gludio_siege_clan',
25 => '@goblin_clan',
26 => '@grave_guard_clan',
27 => '@grave_keeper_clan',
28 => '@hatar_clan',
29 => '@kobold_clan',
30 => '@lizardman_clan',
31 => '@malruk_clan',
32 => '@mandragora_clan',
33 => '@mercenary_siege_clan',
34 => '@mirrorforest_clan',
35 => '@monster_eye_clan',
36 => '@neer_crawler_clan',
37 => '@oel_mahum_clan',
38 => '@ol_mahum_clan',
39 => '@orc_clan',
40 => '@oren_siege_clan',
41 => '@orfen_clan',
42 => '@partisan_clan',
43 => '@porta_clan',
44 => '@q403_clan',
45 => '@queen_ant_clan',
46 => '@scropio_clan',
47 => '@serpent_clan',
48 => '@silenos_clan',
49 => '@skeleton_clan',
50 => '@stakato_clan',
51 => '@succubus_clan',
52 => '@torfe_clan',
53 => '@tyrant_clan',
54 => '@undead_clan',
55 => '@wererat_clan',
56 => '@werewolf_clan',
57 => '@wolf_clan'
);

// 38 - ignore_clan_list
if (!isset($ignore_clan_list)) $ignore_clan_list = '';

// 39 - npc_ai
if (empty($npc_ai)) $npc_ai = $name;

// 40 - corpse_time
if (!isset($corpse_time)) $corpse_time = 7;

// 41 - no_sleep_mode
if (!isset($no_sleep_mode)) $no_sleep_mode = 0;

function MakeList1($arr, $cur = 1)
{
	$len = sizeof($arr);
	$res = "";
	for ($i = 1; $i <= $len; $i++)
	{
		$res .= "<option value={$i}";
		if ($i == $cur) $res .= " selected";
		$res .= ">".$arr[$i]."</option>";
	}
	return $res;
}
function MakeList2($arr, $cur = 1, $name = "name", $memo = "type")
{
	$len = sizeof($arr);
	$res = "";
	for ($i = 1; $i <= $len; $i++)
	{
		$res .= "<option value={$i}";
		if ($i == $cur) $res .= " selected";
		$res .= ">".$arr[$i][$name];
		if (!empty($arr[$i][$memo])) $res .= " (".$arr[$i][$memo].")";
		$res .= "</option>";
	}
	return $res;
}
function ParamByLevel($level, $param = 'exp')
{
	$level = (float) $level;
	$dec = 10;
	switch ($param)
	{
		case "md":
			if ($level < 40) $res = 35.8052 * exp(0.0293 * $level);
			else $res = -24.8581661 + 3.4389099 * $level;
			break;
		case "ma":
			if ($level < 40) $res = 7.9594 * exp(0.0686 * $level);
			else $res = 21.58 * exp(0.045 * $level);
			break;
		case "pd":
			if ($level < 40) $res = 48.9335 * exp(0.0293 * $level);
			else $res = 67.2518 * exp(0.0217 * $level);
			break;
		case "pa":
			if ($level < 40) $res = 11.4903 * exp(0.0692 * $level);
			else $res = 28.5276 * exp(0.0472 * $level);
			break;
		case "mp":
			if ($level < 40) $res = -100.62 + 14.4 * $level;
			else $res = -697.733333 + 29 * $level;
			$dec = 2;
			break;
		case "hp":
			if ($level < 40) $res = 127.6828 * exp(0.0513 * $level);
			else $res = -1102.0639 + 50.6979 * $level;
			break;
		case "sp":
			if ($level < 40) $res = 6.0833 * exp(0.0758 * $level);
			else $res = 16.3043 * exp(0.0522 * $level);
			$dec = 0;
			break;
		default:	// exp
			if ($level < 40) $res = 61127.8388 * exp(0.1412 * $level);
			else $res = 154520.0 * exp(0.1126 * $level);
			$dec = 3;
			break;
	}
	return round($res, $dec);
}

function SkillSID($id, $level)
{
	$aS = file("s_data.txt");
	$sN = "";
	$ok = 0;
	while (list($key, $val) = each($aS)) 
	{
		$aTMP = explode("\t", trim($val));
		if ($aTMP[0] == $id)
		{
			if ($level == 0)		// search max level
			{
				if ($ok == 0)
				{
					$sN = $aTMP[2];
					$ok = 1;
				}
			}
			elseif ($aTMP[1] == $level)
			{
				$sN = $aTMP[2];
				break;
			}
		}
		elseif ($ok == 1)
		{
			break;
		}
	}
	unset($aS);
	return $sN;
}

if ($g == 1 and $id > 0)
{
// Some define
	$getted = "";
	$aKeyRace = array(4290 => 20,4291 => 5,4292 => 2,4293 => 1,4294 => 19,4295 => 15,4296 => 22,4297 => 21,4298 => 7,4299 => 8,4300 => 13,4301 => 3,4302 => 12);

// External level, HP & MP
	$arr = file("npc_info.txt");
	$i = -1;
	while (list($key, $val) = each($arr)) 
	{
		$aTMP = explode("\t", trim($val));
		if ($aTMP[0] == $id)
		{
			$i = $key;
			break;
		}
	}
	unset($arr);
	if ($i != -1)
	{
		if ($aTMP[1] != 0)
		{
			$level = $aTMP[1];
			$getted .= "level, ";
		}
		if ($aTMP[2] != 0) 
		{
			$org_hp = ((float) $aTMP[2]) / 1.58;
			$hp_expr = 1;
			$getted .= "HP, ";
		}
		if ($aTMP[3] != 0) 
		{
			$org_mp = ((float) $aTMP[3]) / 1.11;
			$mp_expr = 1;
			$getted .= "MP, ";
		}
	}
                        
// Name and passive skills
	$arr = file("npc_prop.txt");
	$i = -1;
	while (list($key, $val) = each($arr)) 
	{
		$aTMP = explode("\t", trim($val));
		if ($aTMP[0] == $id)
		{
			$i = $key;
			break;
		}
	}
	unset($arr);
	if ($i != -1)
	{
		$name = $aTMP[1];
		$getted .= "name, ";
		$prop = explode(";", $aTMP[2]);
		while (list($key, $val) = each($prop)) 
		{
			if ($val >= 4290 and $val <= 4302)
			{
				$race = $aKeyRace[$val];
				$getted .= "race, ";
			}
			elseif ($val >= 4303 and $val <= 4310)
			{
				if ($hp_expr == 0) 
				{
					$hp_coeff = $val - 4301;
					$getted .= "hp_coeff, ";
				}
			}
			elseif ($val == 4311)
			{
				if ($hp_expr == 0) 
				{
					$hp_coeff = 0.5;
					$getted .= "hp_coeff, ";
				}
			}
			elseif ($val != 0)
			{
				if ($level < 40)	// level=1 for skills
					$skill_list .= "@".SkillSID($val, 1).";";
				else			// max level for skills
					$skill_list .= "@".SkillSID($val, 0).";";
			}
		}
		if (substr($skill_list, strlen($skill_list) - 1) == ";") 
		{
			$skill_list = substr($skill_list, 0, strlen($skill_list) - 1);
			$getted .= "skills, ";
		}
		if ($aTMP[3] != 0) 
		{
			$collision_radius = $aTMP[3];
			$getted .= "radius, ";
		}
		if ($aTMP[4] != 0) 
		{
			$collision_height = $aTMP[4];
			$getted .= "height, ";
		}
	}	
}

if ($w == 1)
{
	$resnpc  = "npc_begin\t";
	$resnpc .= $aType[$type]."\t";
	$resnpc .= "$id\t";
	$resnpc .= "[$name]\t";
	$resnpc .= "level=$level\t";
	$resnpc .= "exp=".ParamByLevel($level, "exp")."\t";
	$resnpc .= "acquire_exp_rate=$acquire_exp_rate\tundying=0\tcan_be_attacked=1\t";
	$resnpc .= "acquire_sp=".round($aClass[$class]["c_sp"] * ParamByLevel($level, "sp"), 0)."\t";
	$resnpc .= "race=".$aRace[$race]["name"]."\tsex=male\ttemper=100\tsafe_height=100\torg_jump=15\t";
	if (empty($skill_list))
	{
		$skill_list=$aRace[$race]["skill"];
	}
	$resnpc .= "skill_list={".$skill_list."}\t";
	$resnpc .= "magic_list={}\tmax_item=80\titem_make_list={}\t";
	if (empty($corpse_make_list) and $class > 1)
	{
		$tcryst   = floor(min(10, max(0, ($level - 25) / 5)));
		if ($class == 4)		// raid fighter
		{
			$pctcryst = (22 - 2 * $tcryst) / 2;
		}
		elseif ($class > 1)		// raid boses
		{
			$pctcryst = 22 - 2 * $tcryst;
		}
		$corpse_make_list="{[red_soul_crystal_".$tcryst."];1;1;".$pctcryst."};{[blue_soul_crystal_".$tcryst."];1;1;".$pctcryst."};{[green_soul_crystal_".$tcryst."];1;1;".$pctcryst."}";
	}
	$resnpc .= "corpse_make_list={".$corpse_make_list."}\t";
	$resnpc .= "additional_make_list={}\t";
	if (empty($additional_make_multi_list) and $class > 1)
	{
		$tcryst   = floor(min(10, max(0, ($level - 25) / 5)));
		if ($class == 4)		// raid fighter
		{
			$pctcryst = (4.0 - 0.2 * $tcryst) / 2.0;
		}
		elseif ($class > 1)		// raid boses
		{
			$pctcryst = 4.0 - 0.2 * $tcryst;
		}
		$additional_make_multi_list="{{{[adena_of_ancient];".(10 * $level - 10).";".(10 * $level + 10).";100}};70};{{{[red_soul_crystal_".$tcryst."];1;1;33.33};{[blue_soul_crystal_".$tcryst."];1;1;33.33};{[green_soul_crystal_".$tcryst."];1;1;33.33}};".$pctcryst."}";
	}
	$resnpc .= "additional_make_multi_list={".$additional_make_multi_list."}\t";
	$resnpc .= "slot_chest=[]\t";
	$resnpc .= "slot_rhand=[".$aSlot_rhand[$slot_rhand]["name"]."]\t";
	$resnpc .= "slot_lhand=[".$aSlot_lhand[$slot_lhand]."]\t";
	$resnpc .= "base_attack_type=".$aBase_attack_type[$base_attack_type]["name"]."\tbase_can_penetrate=0\t";
	$resnpc .= "base_attack_range=".$aBase_attack_type[$base_attack_type]["base_attack_range"]."\t";
	$resnpc .= "base_damage_range=".$aBase_attack_type[$base_attack_type]["base_damage_range"]."\t";
	$resnpc .= "base_rand_dam=".$aBase_attack_type[$base_attack_type]["base_rand_dam"]."\t";
	$resnpc .= "str=$str\tint=$int\tdex=$dex\twit=$wit\tcon=$con\tmen=$men\t";
	$resnpc .= "hp_increase=$hp_increase\tmp_increase=$mp_increase\torg_hp_regen=$org_hp_regen\torg_mp_regen=$org_mp_regen\t";
	$resnpc .= "ground_low={".$walk_speed.";0;10}\t";
	$resnpc .= "ground_high={".$run_speed.";-30;30}\tunderwater_low={50;0;10}\tunderwater_high={0;0;30}\t";
	if ($fly != 0) $resnpc .= "fly_low={".$walk_speed.";0;10}\tfly_high={".$run_speed.";-30;30}\t";
	else $resnpc .= "fly_low={0;0;10}\tfly_high={0;-30;30}\t";
	if ($float != 0) $resnpc .= "float_low={".$walk_speed.";0;10}\tfloat_high={".$run_speed.";-30;30}\t";
	else $resnpc .= "float_low={0;0;10}\tfloat_high={0;-30;30}\t";
	$resnpc .= "org_earshot=100\tsight={0;0;2500;120;5}\tagro_range=1000\t";
	if ($hp_expr == 0)	
		$resnpc .= "org_hp=". ParamByLevel($level, "hp") * $aClass[$class]["c_hp"] * $hp_coeff."\t";
	else
		$resnpc .= "org_hp={$org_hp}\t";
	if ($mp_expr == 0)	
		$resnpc .= "org_mp=". ParamByLevel($level, "mp") * $aClass[$class]["c_mp"] * $mp_coeff."\t";
	else
		$resnpc .= "org_mp={$org_mp}\t";
	$resnpc .= "base_defend=". ParamByLevel($level, "pd") * $aClass[$class]["c_pd"] * $pdef_coeff."\t";
	$resnpc .= "base_magic_attack=". ParamByLevel($level, "ma") * $aClass[$class]["c_ma"] * $matk_coeff."\t";
	$resnpc .= "base_magic_defend=". ParamByLevel($level, "md") * $aClass[$class]["c_md"] * $mdef_coeff."\t";
	if ($base_attack_type == 2)	// bow - double PAtk
		$resnpc .= "base_physical_attack=". ParamByLevel($level, "pa") * $aClass[$class]["c_pa"] * $patk_coeff * 2.0."\t";
	else				// other weapon
		$resnpc .= "base_physical_attack=". ParamByLevel($level, "pa") * $aClass[$class]["c_pa"] * $patk_coeff."\t";
	$resnpc .= "physical_hit_modify=".$aBase_attack_type[$base_attack_type]["physical_hit_modify"]."\tphysical_avoid_modify=0\t";
	$resnpc .= "base_attack_speed=".$aBase_attack_type[$base_attack_type]["base_attack_speed"]."\t";
	$resnpc .= "base_reuse_delay=".$aBase_attack_type[$base_attack_type]["base_reuse_delay"]."\t";
	$resnpc .= "base_critical=".$aBase_attack_type[$base_attack_type]["base_critical"]."\tmagic_use_speed_modify=0\tstatus={normal}\talign=-324\t";
	$resnpc .= "collision_radius=$collision_radius\tcollision_height=$collision_height\tcategory={}\t";
	$resnpc .= "clan={".$aClan[$clan]."}\tclan_help_range=300\tguild={}\tpledge={}\tpledge_leader=0\talliance={}\talliance_leader=0\tignore_clan_list={}\truler=0\truling_domain={}\t";
	$resnpc .= "npc_ai={[".$npc_ai."]}\tcorpse_time=7\tno_sleep_mode=0\t";
	$resnpc .= "npc_end\n";	
}
?>
<html>
<head>
<title>Make NPC data</title>
<STYLE type=text/css>
body		{font-family: Verdana; font-size: 8px; color: white; BACKGROUND: #0b283b}
table		{font-family: Verdana; font-size: 8pt; color: white; }
td.header	{font-family: Tahoma;  font-size: 11px; color: snow; font-weight: bold}
td.body		{font-family: Verdana; font-size: 11px; color: white;}
td.toph		{font-family: Verdana; font-size: 8pt; color: white; background-color: black; border-bottom: gray 1pt solid; border-left: gray 1pt solid; border-right: gray 1pt solid; border-top: gray 1pt solid}
td.top		{font-family: Verdana; font-size: 8pt; color: white; border-bottom: gray 1pt solid; border-left: gray 1pt solid; border-right: gray 1pt solid; border-top: gray 1pt solid}
td.nob		{font-family: Verdana; font-size: 8pt; color: white; border-bottom: 0pt; border-left: 0pt; border-right: 0pt; border-top: 0pt}
td.s		{font-family: Verdana; font-size: 7pt; color: white; border-bottom: gray 1pt solid; border-left: gray 1pt solid; border-right: gray 1pt solid; border-top: gray 1pt solid}
td.sn		{font-family: Verdana; font-size: 7pt; color: red; border-bottom: gray 1pt solid; border-left: gray 1pt solid; border-right: gray 1pt solid; border-top: gray 1pt solid}
select		{font-family: verdana; font-size: 8pt; color: white; background-color: #202020; border-right: black 1px solid; border-top: black 1px solid; border-left: black 1px solid; border-bottom: black 1px solid;}
input		{font-family: verdana; font-size: 8pt; background-color: #202020; border-right: #ffffff 1px solid; border-top: #ffffff 1px solid; border-left: #ffffff 1px solid; color: #ffffff; border-bottom: #ffffff 1px solid;}
textarea	{font-family: verdana; font-size: 8pt; background-color: #202020; border-right: #ffffff 1px solid; border-top: #ffffff 1px solid; border-left: #ffffff 1px solid; color: #ffffff; border-bottom: #ffffff 1px solid;}
</STYLE>
<script>
var nWindDrop;
var nWindAI;
function Drop()
{
	if (nWindDrop == null || nWindDrop.closed)
	{
		curWnd = window.self;
		nWindDrop = window.open("drop.php?id_npc="+document.param.id.value, "drop");
	}
	else
	{
		nWindDrop.parent.frames("left").document.npc.id_npc.value=document.param.id.value;
		nWindDrop.focus();
	}
}
function AI()
{
	if (nWindAI == null || nWindAI.closed)
	{
		curWnd = window.self;
		nWindAI = window.open("ai.php?id_npc="+document.param.id.value, "ai");
	}
	else
	{
		nWindAI.document.param.id_npc.value=document.param.id.value;
		nWindAI.focus();
	}
}
</script>
</head>
<body TOPMARGIN=5>
<table align=center cellPadding=2 cellSpacing=0 border=0>
<form name=param id=param action=npcdata.php method=post>
<input type=hidden name=w value=1>
<input type=hidden name=org_hp value="<?=$org_hp?>">
<input type=hidden name=org_mp value="<?=$org_mp?>">
<input type=hidden name=hp_expr value="<?=$hp_expr?>">
<input type=hidden name=mp_expr value="<?=$mp_expr?>">
<input type=hidden name=getted value="<?=$getted?>">
<tr>	
	<td class=toph align=center colspan=2><b>Make NPC data</td>
</tr>
<tr>	
	<td width=400 align=right>Class NPC (affect on last coefficients for all params)</td>
	<td width=400 align=left>
		<select name=class style="width:400px"><?=MakeList2($aClass, $class)?></select>
	</td>
</tr>
<tr>	
	<td width=400 align=right>Type NPC</td>
	<td width=400 align=left>
		<select name=type style="width:400px"><?=MakeList1($aType, $type)?></select>
	</td>
</tr>
<tr>	
	<td width=400 align=right>id NPC (must be unique)</td>
	<td width=400 align=left>
		<input type=text name=id value="<?=$id?>" style="width:200px">
		<input type=button value="Get external data by ID" style="color:yellow; width:195px" onclick="window.location='npcdata.php?id='+document.param.id.value+'&g=1'">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Name NPC (must be unique)</td>
	<td width=400 align=left>
		[<input type=text name=name value="<?=$name?>" style="width:390px">]
	</td>
</tr>
<tr>	
	<td width=400 align=right>Level NPC (20 and above. Use for compute all base params)</td>
	<td width=400 align=left>
		<input type=text name=level value="<?=$level?>" style="width:400px">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Exp rate (GetExpByNPCDie = acquire_exp_rate * level^2)</td>
	<td width=400 align=left>
		<input type=text name=acquire_exp_rate value="<?=$acquire_exp_rate?>" style="width:400px">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Race NPC (affect on default passive skills)</td>
	<td width=400 align=left>
		<select name=race style="width:400px"><?=MakeList2($aRace, $race, "name", "skill")?></select>
	</td>
</tr>
<tr>	
	<td width=400 align=right>Skill list</td>
	<td width=400 align=left>
		{<input type=text name=skill_list value="<?=$skill_list?>" style="width:385px">}
	</td>
</tr>
<tr>	
	<td width=400 align=right>Right hand item (weapon)</td>
	<td width=400 align=left>
		<select name=slot_rhand style="width:400px"><?=MakeList2($aSlot_rhand, $slot_rhand, "name", "type")?></select>
	</td>
</tr>
<tr>	
	<td width=400 align=right>Left hand item (shield)</td>
	<td width=400 align=left>
		<select name=slot_lhand style="width:400px"><?=MakeList1($aSlot_lhand, $slot_lhand)?></select>
	</td>
</tr>
<tr>	
	<td width=400 align=right>Attack type (affect on attack params)</td>
	<td width=400 align=left>
		<select name=base_attack_type style="width:400px"><?=MakeList2($aBase_attack_type, $base_attack_type, "name")?></select>
	</td>
</tr>
<tr>	
	<td width=400 align=right>Clan (check manual_pch.txt)</td>
	<td width=400 align=left>
		<select name=clan style="width:400px"><?=MakeList1($aClan, $clan)?></select>
	</td>
</tr>
<tr>	
	<td width=400 align=right>AI (if empty = name)</td>
	<td width=400 align=left>
		{[<input type=text name=npc_ai value="<?=$npc_ai?>" style="width:375px">]}
	</td>
</tr>
<tr>	
	<td width=400 align=right>Spoil/sweep list. One group: {[item1];min;max;%};{...}</td>
	<td width=400 align=left>
		{<input type=text name=corpse_make_list value="<?=$corpse_make_list?>" style="width:385px">}
	</td>
</tr>
<tr>	
	<td width=400 align=right>Drop list. Some groups: {{group1};%1};{{group2};%2};{...}</td>
	<td width=400 align=left>
		{<input type=text name=additional_make_multi_list value="<?=$additional_make_multi_list?>" style="width:385px">}
	</td>
</tr>
<tr>	
	<td width=400 align=right>Base stats (affect on ingame params. For CON=43 HP=1.58*org_hp):</td>
	<td width=400 align=left>
		STR <input type=text name=str value="<?=$str?>" style="width:30px">
		INT <input type=text name=int value="<?=$int?>" style="width:30px">
		DEX <input type=text name=dex value="<?=$dex?>" style="width:30px">
		WIT <input type=text name=wit value="<?=$wit?>" style="width:30px">
		CON <input type=text name=con value="<?=$con?>" style="width:30px">
		MEN <input type=text name=men value="<?=$men?>" style="width:30px">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Regen and increase params:</td>
	<td width=400 align=left>
		hp_incr <input type=text  name=hp_increase  value="<?=$hp_increase?>" style="width:30px">
		mp_incr <input type=text  name=mp_increase  value="<?=$mp_increase?>" style="width:30px">
		hp_regen <input type=text name=org_hp_regen value="<?=$org_hp_regen?>" style="width:30px">
		mp_regen <input type=text name=org_mp_regen value="<?=$org_mp_regen?>" style="width:30px">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Speed and type of territory:</td>
	<td width=400 align=left>
		walk speed <input type=text  name=walk_speed  value="<?=$walk_speed?>" style="width:40px">
		run speed <input type=text  name=run_speed  value="<?=$run_speed?>" style="width:40px">
		fly (0/1) <input type=text name=fly value="<?=$fly?>" style="width:20px">
		float (0/1) <input type=text name=float value="<?=$float?>" style="width:20px">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Size (gremlin - 10/15, wyrm - 29/72, antaras - 300/300):</td>
	<td width=400 align=left>
		radius <input type=text  name=collision_radius  value="<?=$collision_radius?>" style="width:40px">
		height <input type=text  name=collision_height  value="<?=$collision_height?>" style="width:40px">
	</td>
</tr>
<tr>	
	<td width=400 align=right>Coefficients for special mobs:</td>
	<td width=400 align=left>
		<?php if ($hp_coeff != 1)   echo "<font color=red>";?>HP</font> <input type=text   name=hp_coeff   value="<?=$hp_coeff?>"   style="width:30px">
		<?php if ($mp_coeff != 1)   echo "<font color=red>";?>MP</font> <input type=text   name=mp_coeff   value="<?=$mp_coeff?>"   style="width:30px">
		<?php if ($patk_coeff != 1) echo "<font color=red>";?>PAtk</font> <input type=text name=patk_coeff value="<?=$patk_coeff?>" style="width:30px">
		<?php if ($pdef_coeff != 1) echo "<font color=red>";?>PDef</font> <input type=text name=pdef_coeff value="<?=$pdef_coeff?>" style="width:30px">
		<?php if ($matk_coeff != 1) echo "<font color=red>";?>MAtk</font> <input type=text name=matk_coeff value="<?=$matk_coeff?>" style="width:30px">
		<?php if ($mdef_coeff != 1) echo "<font color=red>";?>MDef</font> <input type=text name=mdef_coeff value="<?=$mdef_coeff?>" style="width:30px">
	</td>
</tr>
<tr height=50>	
	<td align=center colspan=2>
		<input type=submit style="color:yellow;width:130px" value="Make NPC">
		<input type=button style="color:yellow;width:130px" value="Drop constructor" onclick="Drop()">
		<input type=button style="color:yellow;width:130px" value="AI constructor" onclick="AI()">
		&nbsp;&nbsp;<input type=button style="color:red;width:130px" value="Clear fields" onclick="window.location='npcdata.php'">
	</td>
</tr>
<tr>	
	<td class=toph align=center colspan=2>npcdata<br><?php if(!empty($getted)) echo "<font color=cyan>Get by ID: $getted";?></td>
</tr>
<tr>	
	<td align=center colspan=2>
<?php
//$pic_name = "pics/{$id}.jpg";
//if (!file_exists($pic_name))
//{
//	echo "<textarea name=resai rows=20 cols=130>$resnpc</textarea>";
//}
//else
//{
//	echo "<img src='{$pic_name}'>";
//	echo "&nbsp;&nbsp;<textarea name=resai rows=25 cols=82>$resnpc</textarea>";
//}
$pic_name = "http://static.lineage2.co.kr/gameinfo/monster/ss/terr_mon_{$id}.jpg";
if ($id > 0) echo "<img src='{$pic_name}'>";
echo "&nbsp;&nbsp;<textarea name=resai rows=25 cols=82>$resnpc</textarea>";
?>
	</td>
</tr>
</form>
</table>
<center><small>&copy; PhD
</body>
</html>
